library kemoUsb;

uses
  SysUtils,
  Classes,
  kemo_usb in '..\delphi\kemo_usb.pas';

{$R *.res}

var
  SaveExit: Pointer;
  kUsb: TKemoUSB;

function kemousb_Connected: boolean; stdcall;
begin
  result:=kUsb.Connected;
end;

function kemousb_SetState(state: byte):boolean; stdcall;
begin
  result:=kUsb.SetState(state);
end;

function kemousb_Connect: boolean; stdcall;
begin
  result:=kUsb.Connect;
end;

procedure kemousb_Disconnect; stdcall;
begin
  kUsb.Disconnect;
end;

procedure LibExit;
begin
  kUsb.Free;
  ExitProc := SaveExit;  // Kette der Exit-Prozeduren wiederherstellen
end;

exports
  kemousb_Connected,
  kemousb_SetState,
  kemousb_Connect,
  kemousb_Disconnect;

begin
  kUsb:=TKemoUSB.Create;
  SaveExit := ExitProc;  // Kette der Exit-Prozeduren speichern
  ExitProc := @LibExit;  // Exit-Prozedur LibExit installieren
end.
 