#include "KemoUSB.h"

void DisplayLastError (char *S)
{
	CHAR MsgBuf;
	LPSTR lpMsgBuf;

	DWORD code;
	lpMsgBuf=&MsgBuf;

	code = GetLastError();
	if ((!code) || (code==997)) return;

	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM, NULL, code, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)&lpMsgBuf, 0, 0);
	if (lpMsgBuf) {
		MessageBox(0, lpMsgBuf, "GetLastError", MB_OK);
		LocalFree(lpMsgBuf); //check
		}
	else{ 
		std::stringstream ss;
		ss << code;
		std::string tmp = ss.str();
		//std::wstring stemp = std::wstring(tmp.begin(), tmp.end());
		const char * str = tmp.c_str();
		//const wchar_t *str = stemp.c_str();
		MessageBox(0, str, "GetLastError", MB_OK);
	}
}