//#pragma comment (lib, "SLABHIDDevice.lib")
#pragma once
#include "../KemoUSBLib/KemoUSB.h"
#include <dbt.h>
extern "C" {
#include <hidsdi.h>
}
namespace kuExample {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	using namespace System::ComponentModel; 
 
	/// <summary>
	/// Summary for Form1
	/// </summary>
	public ref class kuMain : public System::Windows::Forms::Form
	{
	DWORD last_WMDC;
	public:
		KemoUSB *kemo;

		kuMain(void)
		{
			InitializeComponent();
			kemo=new(KemoUSB);
			last_WMDC=0;

		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~kuMain()
		{
			if (components)
			{
				delete kemo;
				delete components;
			}
		}

	virtual void WndProc(System::Windows::Forms::Message %m) override
		{
		switch (m.Msg){
		case WM_DEVICECHANGE:
			DWORD temp;
			temp = GetTickCount();
			if (temp - last_WMDC > 1000) {
			if (kemo->Connected()) cbConnected->Checked = true;
			else {
					last_WMDC = GetTickCount();
					Sleep(1000);
					cbConnected->Checked = kemo->Connect();
				}
			}
			break;
		default:
			break;
		}
		Form::WndProc(m);
		}
	private: System::Windows::Forms::CheckBox^  cbConnected;
	private: System::Windows::Forms::CheckBox^  checkBox1;
	private: System::Windows::Forms::CheckBox^  checkBox2;
	private: System::Windows::Forms::CheckBox^  checkBox3;
	private: System::Windows::Forms::CheckBox^  checkBox4;
	private: System::Windows::Forms::CheckBox^  checkBox5;
	private: System::Windows::Forms::CheckBox^  checkBox6;
	private: System::Windows::Forms::CheckBox^  checkBox7;
	private: System::Windows::Forms::CheckBox^  checkBox8;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->cbConnected = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox1 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox2 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox3 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox4 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox5 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox6 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox7 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox8 = (gcnew System::Windows::Forms::CheckBox());
			this->SuspendLayout();
			// 
			// cbConnected
			// 
			this->cbConnected->AutoSize = true;
			this->cbConnected->Location = System::Drawing::Point(58, 10);
			this->cbConnected->Margin = System::Windows::Forms::Padding(2, 2, 2, 2);
			this->cbConnected->Name = L"cbConnected";
			this->cbConnected->Size = System::Drawing::Size(78, 17);
			this->cbConnected->TabIndex = 0;
			this->cbConnected->Text = L"Connected";
			this->cbConnected->UseVisualStyleBackColor = true;
			this->cbConnected->Click += gcnew System::EventHandler(this, &kuMain::cbConnectedClick);
			// 
			// checkBox1
			// 
			this->checkBox1->AutoSize = true;
			this->checkBox1->Location = System::Drawing::Point(57, 40);
			this->checkBox1->Margin = System::Windows::Forms::Padding(2, 2, 2, 2);
			this->checkBox1->Name = L"checkBox1";
			this->checkBox1->Size = System::Drawing::Size(32, 17);
			this->checkBox1->TabIndex = 1;
			this->checkBox1->Text = L"1";
			this->checkBox1->UseVisualStyleBackColor = true;
			this->checkBox1->Click += gcnew System::EventHandler(this, &kuMain::CheckBoxClick);
			// 
			// checkBox2
			// 
			this->checkBox2->AutoSize = true;
			this->checkBox2->Location = System::Drawing::Point(57, 62);
			this->checkBox2->Margin = System::Windows::Forms::Padding(2, 2, 2, 2);
			this->checkBox2->Name = L"checkBox2";
			this->checkBox2->Size = System::Drawing::Size(32, 17);
			this->checkBox2->TabIndex = 2;
			this->checkBox2->Text = L"2";
			this->checkBox2->UseVisualStyleBackColor = true;
			this->checkBox2->Click += gcnew System::EventHandler(this, &kuMain::CheckBoxClick);
			// 
			// checkBox3
			// 
			this->checkBox3->AutoSize = true;
			this->checkBox3->Location = System::Drawing::Point(57, 84);
			this->checkBox3->Margin = System::Windows::Forms::Padding(2, 2, 2, 2);
			this->checkBox3->Name = L"checkBox3";
			this->checkBox3->Size = System::Drawing::Size(32, 17);
			this->checkBox3->TabIndex = 3;
			this->checkBox3->Text = L"3";
			this->checkBox3->UseVisualStyleBackColor = true;
			this->checkBox3->Click += gcnew System::EventHandler(this, &kuMain::CheckBoxClick);
			// 
			// checkBox4
			// 
			this->checkBox4->AutoSize = true;
			this->checkBox4->Location = System::Drawing::Point(57, 106);
			this->checkBox4->Margin = System::Windows::Forms::Padding(2, 2, 2, 2);
			this->checkBox4->Name = L"checkBox4";
			this->checkBox4->Size = System::Drawing::Size(32, 17);
			this->checkBox4->TabIndex = 4;
			this->checkBox4->Text = L"4";
			this->checkBox4->UseVisualStyleBackColor = true;
			this->checkBox4->Click += gcnew System::EventHandler(this, &kuMain::CheckBoxClick);
			// 
			// checkBox5
			// 
			this->checkBox5->AutoSize = true;
			this->checkBox5->Location = System::Drawing::Point(57, 128);
			this->checkBox5->Margin = System::Windows::Forms::Padding(2, 2, 2, 2);
			this->checkBox5->Name = L"checkBox5";
			this->checkBox5->Size = System::Drawing::Size(32, 17);
			this->checkBox5->TabIndex = 5;
			this->checkBox5->Text = L"5";
			this->checkBox5->UseVisualStyleBackColor = true;
			this->checkBox5->Click += gcnew System::EventHandler(this, &kuMain::CheckBoxClick);
			// 
			// checkBox6
			// 
			this->checkBox6->AutoSize = true;
			this->checkBox6->Location = System::Drawing::Point(57, 150);
			this->checkBox6->Margin = System::Windows::Forms::Padding(2, 2, 2, 2);
			this->checkBox6->Name = L"checkBox6";
			this->checkBox6->Size = System::Drawing::Size(32, 17);
			this->checkBox6->TabIndex = 6;
			this->checkBox6->Text = L"6";
			this->checkBox6->UseVisualStyleBackColor = true;
			this->checkBox6->Click += gcnew System::EventHandler(this, &kuMain::CheckBoxClick);
			// 
			// checkBox7
			// 
			this->checkBox7->AutoSize = true;
			this->checkBox7->Location = System::Drawing::Point(57, 171);
			this->checkBox7->Margin = System::Windows::Forms::Padding(2, 2, 2, 2);
			this->checkBox7->Name = L"checkBox7";
			this->checkBox7->Size = System::Drawing::Size(32, 17);
			this->checkBox7->TabIndex = 7;
			this->checkBox7->Text = L"7";
			this->checkBox7->UseVisualStyleBackColor = true;
			this->checkBox7->Click += gcnew System::EventHandler(this, &kuMain::CheckBoxClick);
			// 
			// checkBox8
			// 
			this->checkBox8->AutoSize = true;
			this->checkBox8->Location = System::Drawing::Point(57, 193);
			this->checkBox8->Margin = System::Windows::Forms::Padding(2, 2, 2, 2);
			this->checkBox8->Name = L"checkBox8";
			this->checkBox8->Size = System::Drawing::Size(32, 17);
			this->checkBox8->TabIndex = 8;
			this->checkBox8->Text = L"8";
			this->checkBox8->UseVisualStyleBackColor = true;
			this->checkBox8->Click += gcnew System::EventHandler(this, &kuMain::CheckBoxClick);
			// 
			// kuMain
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(221, 218);
			this->Controls->Add(this->checkBox8);
			this->Controls->Add(this->checkBox7);
			this->Controls->Add(this->checkBox6);
			this->Controls->Add(this->checkBox5);
			this->Controls->Add(this->checkBox4);
			this->Controls->Add(this->checkBox3);
			this->Controls->Add(this->checkBox2);
			this->Controls->Add(this->checkBox1);
			this->Controls->Add(this->cbConnected);
			this->Margin = System::Windows::Forms::Padding(2, 2, 2, 2);
			this->Name = L"kuMain";
			this->Text = L"KEMO USB Example Program";
			this->Load += gcnew System::EventHandler(this, &kuMain::FormCreate);
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
	


	private: System::Void cbConnectedClick(System::Object^  sender, System::EventArgs^  e) {
		 if (cbConnected->Checked) cbConnected->Checked = kemo->Connect();
		 else kemo->Disconnect();	 
		 }
	private: System::Void CheckBoxClick(System::Object^  sender, System::EventArgs^  e) {
		 unsigned char b=0;
		 if (checkBox1->Checked) b = (b | 0x01);
		 if (checkBox2->Checked) b = (b | 0x02);
		 if (checkBox3->Checked) b = (b | 0x04);
		 if (checkBox4->Checked) b = (b | 0x08);
		 if (checkBox5->Checked) b = (b | 0x10);
		 if (checkBox6->Checked) b = (b | 0x20);
		 if (checkBox7->Checked) b = (b | 0x40);
		 if (checkBox8->Checked) b = (b | 0x80);
		 kemo->SetState(b);
		 }

private: System::Void FormCreate(System::Object^  sender, System::EventArgs^  e) {
		 cbConnected->Checked = kemo->Connect();
		 }

};
}

